//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37EBCBB6F4C8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37EBCBB6F4C8.cm

//## begin module%37EBCBB6F4C8.cp preserve=no
//## end module%37EBCBB6F4C8.cp

//## Module: XSModelFunction%37EBCBB6F4C8; Package specification
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/FunctionUtils/XSModelFunction.h

#ifndef XSMODELFUNCTION_H
#define XSMODELFUNCTION_H 1

//## begin module%37EBCBB6F4C8.additionalIncludes preserve=no
//## end module%37EBCBB6F4C8.additionalIncludes

//## begin module%37EBCBB6F4C8.includes preserve=yes
//## end module%37EBCBB6F4C8.includes

// xsTypes
#include <main/xsTypes.h>
// Error
#include <XSUtil/Error/Error.h>
// ComponentInfo
#include <XSUtil/FunctionUtils/ComponentInfo.h>
//## begin module%37EBCBB6F4C8.declarations preserve=no
//## end module%37EBCBB6F4C8.declarations

//## begin module%37EBCBB6F4C8.additionalDeclarations preserve=yes
#ifdef INITPACKAGE
#       include <funcType.h>
#else
#       include <XSUtil/FunctionUtils/funcType.h>
#endif

#include <XSUtil/Parse/XSparse.h>  // invalid exception
#include <XSUtil/Parse/MathExpression.h>
//## end module%37EBCBB6F4C8.additionalDeclarations


//## Class: XSModelFunction%37EBD27A1760
//## Category: XSUtil::FunctionUtils%48DBD01C0111
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3E319E380120;RealArray { -> }
//## Uses: <unnamed>%3FC7B4C603B0;std::ifstream { -> }

class XSModelFunction 
{
  public:
    //## Class: NoSuchComponent%3FBA6F300060
    //## Category: XSUtil::FunctionUtils%48DBD01C0111
    //## Subsystem: XSUtil::FunctionUtils%48DBCC590164
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoSuchComponent : public YellowAlert  //## Inherits: <unnamed>%3FBA6F620269
    {
      public:
        //## Constructors (generated)
          NoSuchComponent();

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~XSModelFunction() = 0;


    //## Other Operations (specified)
      //## Operation: operator()%37EBD61DFCC0;    C++
      virtual void operator () (const RealArray& energyArray, const RealArray& params, int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, const string& initString) const = 0;

      //## Operation: updateComponentList%3E5A3391020A
      static void updateComponentList (const string& modelDatFile, bool isStandard = false);

      //## Operation: operator()%3F7894400159;    C++
      virtual void operator () (const EnergyPointer& energyArray, const std::vector<Real>& params, GroupFluxContainer& fluxArrays, GroupFluxContainer& fluxErrArrays, MixBase** mixGenerator, const string& modelName) const = 0;

      //## Operation: printComponentList%3FB92430038B;      C++
      static void printComponentList (std::ostream& s, const string& name = "");

      //## Operation: nameCache%3FBA6E7B03C7
      static std::vector<ComponentInfo> nameCache (const string& fullName	// Full name is the expression representing a model typed
      	// by the user. Only its first two characters are used
      	// here.
      	// Full name resolution in the case of duplicate names
      	// is deferred to the fullMatch function.
      );

      //## Operation: fullMatch%3FBA707800D3
      static ComponentInfo fullMatch (const string& fullName);

      //## Operation: clone%481B1E8D0387
      virtual XSModelFunction* clone () = 0;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFunctions::<unnamed>%3FBA6BFF0062
      //## Role: XSModelFunction::nameCache%3FBA6BFF0063
      //## Qualifier: shortName%3FBA6BFF0064; const string&
      static const NameCacheType& nameCache ();
      static void nameCache (const string& shortName, const ComponentInfo& value);

  public:
  protected:
    //## Constructors (generated)
      XSModelFunction();

      XSModelFunction(const XSModelFunction &right);

  private:
    //## Assignment Operation (generated)
      XSModelFunction & operator=(const XSModelFunction &right);


    //## Other Operations (specified)
      //## Operation: exactMatch%40A1348700B0
      static NameCacheType::iterator exactMatch (const string& fullName);

  private: //## implementation
    // Data Members for Associations

      //## Association: XSFunctions::<unnamed>%3FBA6BFF0062
      //## begin XSModelFunction::nameCache%3FBA6BFF0063.role preserve=no  public: static NameCacheType { -> 1..nVHgN}
      static NameCacheType s_nameCache;
      //## end XSModelFunction::nameCache%3FBA6BFF0063.role

};

//## Class: XSCall%37F11F9926D8; Parameterized Class
//	Interface for calling model calculation functions
//## Category: XSUtil::FunctionUtils%48DBD01C0111
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Persistence: Transient
//## Cardinality/Multiplicity: n



template <typename T>
class XSCall : public XSModelFunction  //## Inherits: <unnamed>%3E319B420391
{
  public:
    //## Constructors (generated)
      XSCall(const XSCall< T > &right);

    //## Constructors (specified)
      //## Operation: XSCall%3E31B07201E2
      XSCall (T* generator);

    //## Destructor (generated)
      virtual ~XSCall();


    //## Other Operations (specified)
      //## Operation: operator()%3E319AEC0230
      virtual void operator () (const RealArray& energyArray, const RealArray& params, int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, const string& initString = string()) const;

      //## Operation: operator()%3F78958B0355;    C++
      virtual void operator () (const EnergyPointer& energyArray, const std::vector<Real>& parameterValues, GroupFluxContainer& fluxArrays, GroupFluxContainer& fluxErrArrays, MixBase** mixGenerator = 0, const string& modelName = string()) const;

      //## Operation: clone%481B1F600148
      virtual XSCall<T>* clone ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: generator%3E319AF80296
      T* generator () const;
      void generator (T* value);

  protected:
  private:
    //## Constructors (generated)
      XSCall();

    //## Assignment Operation (generated)
      XSCall< T > & operator=(const XSCall< T > &right);

  private: //## implementation
    // Data Members for Class Attributes

      //## begin XSCall::generator%3E319AF80296.attr preserve=no  public: T* {U} 
      T* m_generator;
      //## end XSCall::generator%3E319AF80296.attr

};

// Class XSModelFunction::NoSuchComponent 

// Class XSModelFunction 

inline XSModelFunction::XSModelFunction()
  //## begin XSModelFunction::XSModelFunction%37EBD27A1760_const.initialization preserve=yes
  //## end XSModelFunction::XSModelFunction%37EBD27A1760_const.initialization
{
  //## begin XSModelFunction::XSModelFunction%37EBD27A1760_const.body preserve=yes
  //## end XSModelFunction::XSModelFunction%37EBD27A1760_const.body
}

inline XSModelFunction::XSModelFunction(const XSModelFunction &right)
  //## begin XSModelFunction::XSModelFunction%37EBD27A1760_copy.initialization preserve=yes
  //## end XSModelFunction::XSModelFunction%37EBD27A1760_copy.initialization
{
  //## begin XSModelFunction::XSModelFunction%37EBD27A1760_copy.body preserve=yes
  //## end XSModelFunction::XSModelFunction%37EBD27A1760_copy.body
}


//## Get and Set Operations for Associations (inline)

inline const NameCacheType& XSModelFunction::nameCache ()
{
  //## begin XSModelFunction::nameCache%3FBA6BFF0063.get preserve=no
  return s_nameCache;
  //## end XSModelFunction::nameCache%3FBA6BFF0063.get
}

inline void XSModelFunction::nameCache (const string& shortName, const ComponentInfo& value)
{
  //## begin XSModelFunction::nameCache%3FBA6BFF0063.qualset preserve=yes
  s_nameCache.insert(NameCacheType::value_type(shortName,value));
  //## end XSModelFunction::nameCache%3FBA6BFF0063.qualset
}

// Parameterized Class XSCall 


//## Other Operations (inline)
template <typename T>
inline XSCall<T>* XSCall<T>::clone ()
{
  //## begin XSCall::clone%481B1F600148.body preserve=yes
   return new XSCall<T>(*this);
  //## end XSCall::clone%481B1F600148.body
}

//## Get and Set Operations for Class Attributes (inline)

template <typename T>
inline T* XSCall<T>::generator () const
{
  //## begin XSCall::generator%3E319AF80296.get preserve=no
  return m_generator;
  //## end XSCall::generator%3E319AF80296.get
}

template <typename T>
inline void XSCall<T>::generator (T* value)
{
  //## begin XSCall::generator%3E319AF80296.set preserve=no
  m_generator = value;
  //## end XSCall::generator%3E319AF80296.set
}

// Parameterized Class XSCall 

template <typename T>
XSCall<T>::XSCall(const XSCall<T> &right)
  //## begin XSCall::XSCall%37F11F9926D8_copy.initialization preserve=yes
  : XSModelFunction(right),
    m_generator(right.m_generator) // default non-owning - shallow copy
                                   // (assume it's a function pointer)
  //## end XSCall::XSCall%37F11F9926D8_copy.initialization
{
  //## begin XSCall::XSCall%37F11F9926D8_copy.body preserve=yes
  //## end XSCall::XSCall%37F11F9926D8_copy.body
}

template <typename T>
XSCall<T>::XSCall (T* generator)
  //## begin XSCall::XSCall%3E31B07201E2.hasinit preserve=yes
  : m_generator(generator)
  //## end XSCall::XSCall%3E31B07201E2.hasinit
  //## begin XSCall::XSCall%3E31B07201E2.initialization preserve=yes
  //## end XSCall::XSCall%3E31B07201E2.initialization
{
  //## begin XSCall::XSCall%3E31B07201E2.body preserve=yes
  //## end XSCall::XSCall%3E31B07201E2.body
}


template <typename T>
XSCall<T>::~XSCall()
{
  //## begin XSCall::~XSCall%37F11F9926D8_dest.body preserve=yes
  //## end XSCall::~XSCall%37F11F9926D8_dest.body
}



//## Other Operations (implementation)
template <typename T>
void XSCall<T>::operator () (const RealArray& energyArray, const RealArray& params, int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, const string& initString) const
{
  //## begin XSCall::operator()%3E319AEC0230.body preserve=yes
  //## end XSCall::operator()%3E319AEC0230.body
}

template <typename T>
void XSCall<T>::operator () (const EnergyPointer& energyArray, const std::vector<Real>& parameterValues, GroupFluxContainer& fluxArrays, GroupFluxContainer& fluxErrArrays, MixBase** mixGenerator, const string& modelName) const
{
  //## begin XSCall::operator()%3F78958B0355.body preserve=yes
  //## end XSCall::operator()%3F78958B0355.body
}

//## begin module%37EBCBB6F4C8.epilog preserve=yes
template  <> 
void XSCall<xsf77Call>::operator() (const RealArray& energyArray, const RealArray& params,
                        int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, 
                        const string& initString) const;

template  <> 
void XSCall<xsF77Call>::operator() (const RealArray& energyArray, const RealArray& params,
                        int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, 
                        const string& initString) const;

template  <> 
void XSCall<xsccCall>::operator() (const RealArray& energyArray, const RealArray& params,
                        int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, 
                        const string& initString) const;


template  <> 
void XSCall<XSCCall>::operator() (const RealArray& energyArray, const RealArray& params,
                        int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, 
                        const string& initString) const;

template  <> 
void XSCall<XSMixCCall>::operator() (const EnergyPointer& energyArray, 
                        const std::vector<Real>& parameterValues, GroupFluxContainer& flux,
                        GroupFluxContainer& fluxError, MixBase** mixGenerator, 
                        const string& modelName) const;

template  <> 
void XSCall<xsmixcall>::operator() (const EnergyPointer& energyArray, 
                        const std::vector<Real>& parameterValues, GroupFluxContainer& flux,
                        GroupFluxContainer& fluxError, MixBase** mixGenerator, 
                        const string& modelName) const;
                        
template <>
void XSCall<MathExpression>::operator() (const RealArray& energyArray, const RealArray& params,
                        int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray, 
                        const string& initString) const;

template <>
XSCall<MathExpression>::~XSCall();

template <>
XSCall<MathExpression>::XSCall(const XSCall<MathExpression> &right);

//## end module%37EBCBB6F4C8.epilog


#endif
